﻿Global *m=AllocateMemory(65536)
Global Dim typ.a(65536)
Global adra
Global disend
Global itemsel=-1
Enumeration
  #type_code
  #type_byte
  #type_word
EndEnumeration

Enumeration
  #ds
EndEnumeration

Enumeration
  #file_open
  #file_save
  #file_quit
  
  #mark_code
  #mark_byte
  #mark_word
EndEnumeration

Procedure.s sbyt(b.a)
  ProcedureReturn RSet(Hex(b),2,"0")
EndProcedure

Procedure.s swor(b.u)
  ProcedureReturn RSet(Hex(b),4,"0")
EndProcedure

Procedure disas()
  ca.u=adra
  si=GetGadgetState(#ds)
  ClearGadgetItems(#ds)
  While ca<disend;adra+fs
    caa=ca
    Select typ(ca)
      Case #type_code
        op.a=PeekA(*m+ca)
        i$=sbyt(op)+" "
        ca+1
        m$=PeekS(?mn+op*5,3,#PB_Ascii)
        If PeekA(?mn+op*5+4)=42;undocumented
          m$="*"+m$
        EndIf
        o$=""
        Select PeekA(?mn+op*5+3)
          Case 00 :;impl
          Case 01 :;(ind,X)
            op1.a=PeekA(*m+ca)
            ca+1
            o$="($"+sbyt(op1)+",X)"
            i$=i$+sbyt(op1)+" "
          Case 02 :;zpg
            op1.a=PeekA(*m+ca)
            ca+1
            o$="$"+sbyt(op1)
            i$=i$+sbyt(op1)+" "
          Case 03 :;#
            op1.a=PeekA(*m+ca)
            ca+1
            o$="#$"+sbyt(op1)
            i$=i$+sbyt(op1)+" "
          Case 04 :;A
            o$="A"
          Case 05 :;(ind)
            op1.a=PeekA(*m+ca)
            ca+1
            op2.a=PeekA(*m+ca)
            ca+1
            o$="($"+RSet(Hex(op1+256*op2),4,"0")+")"
            i$=i$+sbyt(op1)+" "
          Case 06 :;abs
            op1.a=PeekA(*m+ca)
            ca+1
            op2.a=PeekA(*m+ca)
            ca+1
            o$="$"+RSet(Hex(op1+256*op2),4,"0")
            i$=i$+sbyt(op1)+" "+sbyt(op2)
          Case 07 :;rel
            op.a=PeekA(*m+ca)
            ca+1
            If op&$80
              ra.u=ca-((op!$FF)+1)
            Else
              ra.u=ca+op
            EndIf
            o$="$"+RSet(Hex(ra),4,"0")
            i$=i$+sbyt(op)+" "
          Case 08 :;(ind),Y
            op1.a=PeekA(*m+ca)
            ca+1
            o$="($"+sbyt(op1)+"),Y"
            i$=i$+sbyt(op1)+" "
          Case 09 :;zpg,X
            op1.a=PeekA(*m+ca)
            ca+1
            o$="$"+sbyt(op1)+",X"
            i$=i$+sbyt(op1)+" "
          Case 10 :;zpg,Y
            op1.a=PeekA(*m+ca)
            ca+1
            o$="$"+sbyt(op1)+",Y"
            i$=i$+sbyt(op1)+" "
          Case 11 :;abs,Y
            op1.a=PeekA(*m+ca)
            ca+1
            op2.a=PeekA(*m+ca)
            ca+1
            o$="$"+RSet(Hex(op1+256*op2),4,"0")+",Y"
            i$=i$+sbyt(op1)+" "+sbyt(op2)
          Case 12 :;abs,X
            op1.a=PeekA(*m+ca)
            ca+1
            op2.a=PeekA(*m+ca)
            ca+1
            ;o$="$"+RSet(Hex(op1+256*op2),4,"0")+",X"
            o$="$"+swor(op1+256*op2)+",X"
            i$=i$+sbyt(op1)+" "+sbyt(op2)
          Default:
            Debug "wrong address"
            End
        EndSelect
      Case #type_byte
        op1.a=PeekA(*m+ca)
        ca+1
        o$=sbyt(op1)
        i$=o$
        m$="DEFB $"+o$
        If op1>=32 And op1<=127
          m$=m$+"; "+Chr(op1)
        EndIf
        o$=""
      Case #type_word
        op1.a=PeekA(*m+ca)
        ca+1
        op2.a=PeekA(*m+ca)
        ca+1
        m$="DEFW"
        o$=swor(op1+256*op2)
        i$=o$
    EndSelect
    ;AddGadgetItem(#ds,-1,Hex(caa)+" "+LSet(i$,9," ")+m$+" "+o$)
    AddGadgetItem(#ds,-1,Trim(swor(caa)+Chr(10)+LSet(i$,9," ")+Chr(10)+m$+" "+o$))
  Wend
  SetGadgetState(#ds,si)
EndProcedure

Procedure loadf(f$)
  ;!adra,disend
  e$=LCase(Right(f$,3))
  fs=FileSize(f$)
  If fs
    If ReadFile(0,f$)
      If e$="prg"
        adra=ReadWord(0)
        fs-2
        ReadData(0,*m+adra,fs)
        CloseFile(0)
        disend=adra+fs
        ProcedureReturn 1
      ElseIf e$="xex"
        ab.u=ReadWord(0)
        If ab=$FFFF
          ab.u=ReadWord(0)
          ae.u=ReadWord(0)
          adra=ab
          disend=ae+1
          ReadData(0,*m+adra,ae-ab+1)
          CloseFile(0)
          ProcedureReturn 1
        Else
          CloseFile(0)
          MessageRequester("dis6502","not .xex file:"+f$)
          ProcedureReturn 0
        EndIf 
      Else ;bin
        a$ = InputRequester("Starting Address", "input address($ for hex)", "0000")
        If a$=""
          MessageRequester("dis6502","Cancelled")
          ProcedureReturn 0
        Else
          adra=Val(a$)
          ;      If ReadFile(0,f$)
          ReadData(0,*m+adra,fs)
          CloseFile(0)
          disend=adra+fs
          ProcedureReturn 1
        EndIf
      EndIf;bin
    Else
      MessageRequester("dis6502","Error read:"+f$)
    EndIf ; ReadFile(0,f$)
    
  Else
    MessageRequester("dis6502","Empty file:"+f$)
  EndIf ; if fs
  ProcedureReturn 0
EndProcedure

Procedure lnd(fn.s)
  If loadf(fn)
    disas()
  EndIf
EndProcedure

If OpenWindow(0, 0, 0, 640, 480, "dis6502", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  ListIconGadget(#ds,  0, 0, 640, 480, "Adr", 60, #PB_ListIcon_FullRowSelect|#PB_ListIcon_MultiSelect|#PB_ListIcon_AlwaysShowSelection);|#LVS_NOCOLUMNHEADER)
  AddGadgetColumn(#ds,1,"Byte",120)
  AddGadgetColumn(#ds,2,"Code",160)
  AddGadgetColumn(#ds,3,"Remark",200)
  EnableGadgetDrop(#ds,#PB_Drop_Files,#PB_Drag_Copy)
  
  If(OpenLibrary(0, "GDI32.DLL"))
    hfont=CallFunction(0, "AddFontMemResourceEx", ?font, (?end_font -?font), 0, @"1")
    ;SendMessage_(GadgetID(#ds),#WM_SETFONT,hfont,$0)
    LoadFont(0,"teletext",14)
    SetGadgetFont(#ds,FontID(0))
    CloseLibrary(0)
  Else
    hfont=0
  EndIf
  ;  hfont=AddFontMemResourceEx_(?font,?end_font-?font,0,@"1")
  ;LoadFont(0,"teletext",14)
  ;SetGadgetFont(#ds,FontID(0))
  ;;SendMessage_(GadgetID(#ds),#WM_SETFONT,hfont,$10000)
  
  If CreatePopupMenu(1)
    MenuItem(#mark_code, "Mark as code")
    MenuItem(#mark_byte, "Mark as byte")
    MenuItem(#mark_word, "Mark as word")
  EndIf
  
  
  If CreateMenu(0, WindowID(0))    ; menu creation starts....
    MenuTitle("File")
    MenuItem(#file_open, "Open"   +Chr(9)+"Ctrl+O")
    MenuItem(#file_save, "Save"   +Chr(9)+"Ctrl+S")
    MenuItem(#file_quit, "Quit"  +Chr(9)+"Ctrl+Q")
  EndIf
  AddKeyboardShortcut(0,#PB_Shortcut_Control|#PB_Shortcut_O,#file_open)
  AddKeyboardShortcut(0,#PB_Shortcut_Control|#PB_Shortcut_S,#file_save)
  AddKeyboardShortcut(0,#PB_Shortcut_Control|#PB_Shortcut_Q,#file_quit)
  
  StandardFile$ = GetCurrentDirectory()
  For i=0 To 65535
    typ(i)=#type_code
  Next i
  
  If CountProgramParameters()
    lnd(ProgramParameter(0))
  EndIf
  ;lnd("fajlo.bin")
  ;  If loadf("fajlo.bin")
  ;If loadf("pls.prg")
  ;   If loadf("mos.xex")
  ;     disas()
  ;   EndIf
  Repeat
    ev=WaitWindowEvent()
    ;     If GetAsyncKeyState_(#VK_ESCAPE)&32768
    ;       Break
    ;     EndIf
    
    Select ev
        
      Case #PB_Event_GadgetDrop
        lnd(EventDropFiles())
        ;         If loadf(EventDropFiles())
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #ds
            If EventType()=#PB_EventType_LeftDoubleClick
              ise=GetGadgetState(#ds)
              If ise>=0
                i$=GetGadgetItemText(#ds,ise,3)
                i$ = InputRequester("Remark", "Add Remark", i$)
                If i$<>""
                  SetGadgetItemText(#ds,ise,i$,3)
            EndIf
            EndIf
            EndIf
            If EventType()=#PB_EventType_RightClick
              ise=GetGadgetState(#ds)
              If ise>=0
                i$=GetGadgetItemText(#ds,ise)
                itemsel=Val("$"+i$)
                DisplayPopupMenu(1, WindowID(0))
              EndIf
            EndIf
        EndSelect
        
      Case #PB_Event_Menu
        Select EventMenu()
          Case #file_save
            
            
            Pattern$ = "listinf (*.lst)|*.lst"
            File$ = SaveFileRequester("Please choose file to save", StandardFile$, Pattern$, 0)
            If File$
              Result = MessageRequester("Save listing", "Include bytes?", #PB_MessageRequester_YesNoCancel) 

              If LCase(Right(File$,3))<>"lst"
                File$+".lst"
              EndIf
              dan=CountGadgetItems(#ds)
              If dan
                If CreateFile(1,File$)
                  For i=0 To dan
                    l$=GetGadgetItemText(#ds,i,0)
                    If Result=#PB_MessageRequester_Yes 
                      l$=l$+" "+GetGadgetItemText(#ds,i,1)
                    EndIf
                    l$=l$+" "+GetGadgetItemText(#ds,i,2)
                    rem$=GetGadgetItemText(#ds,i,3)
                    If Trim(rem$)<>""
                      rem$=" ; "+rem$
                      l$+rem$
                    EndIf
                    WriteStringN(1,l$)
                  Next i
                  CloseFile(1)
                EndIf
              EndIf
            EndIf
            
          Case #file_open
            Pattern$ = "All files (*.*)|*.*"
            File$ = OpenFileRequester("Please choose file to load", StandardFile$, Pattern$, 0)
            If File$
              StandardFile$=GetPathPart(File$)
              lnd(File$)
            EndIf
          Case #mark_word
            If itemsel<>-1
              typ(itemsel)=#type_word
              typ((itemsel+1)&$FFFF)=#type_byte
              itemsel=-1
              disas()
            EndIf
            
          Case #mark_code
            If itemsel<>-1
              typ(itemsel)=#type_code
              itemsel=-1
              disas()
            EndIf
            
          Case #mark_byte
            If itemsel<>-1
              typ(itemsel)=#type_byte
              itemsel=-1
              disas()
            EndIf
          Case #file_quit : Break
        EndSelect
    EndSelect
    
  Until ev = #PB_Event_CloseWindow
  
EndIf
;RemoveFontMemResourceEx_(hfont)
If hfont
  If(OpenLibrary(0, "GDI32.DLL"))
    CallFunction(0, "RemoveFontMemResourceEx",hfont);<>0 if OK,0 if error
    CloseLibrary(0)
  EndIf
EndIf
FreeMemory(*m)
DataSection
  mn:
  IncludeBinary "mnemf_2.txt"
  font:
  IncludeBinary "teletext-font.fon"
  end_font:
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 297
; FirstLine = 293
; Folding = -
; EnableXP
; UseIcon = 6502.ico
; Executable = 6502disas.exe
; CommandLine = 6502opc.bin